Option Explicit

Const bbstree_2ch   = "2ch"
Const bbstree_machi = "Machi"

Const bbsFolder = "BBS"
Const treeFile = "bbstree.txt"

Const lockFile = "..\lock.txt"
Const v2cCache = "v2cCache.txt"

Const adTypeBinary = 1
Const adTypeText   = 2

Const enc_UTF8 = "UTF-8"
Const enc_SJIS = "SHIFT-JIS"

'Const adCR   = 13
'Const adCRLF = -1
Const adLF   = 10

Const adReadLine = -2
Const adWriteLine = 1

Const adSaveCreateNotExist  = 1
Const adSaveCreateOverWrite = 2

Const ext_len = 4
Const ext_dat = ".dat"
Const ext_cgi = ".cgi"
Const ext_syn = ".syn"
Const ext_tmp = ".tmp"

Dim objFso
Dim objFile
Dim objShell
Dim outStrm

Dim v2c_Folder
Dim syncFolder

Dim strVal
Dim aryStrings

Dim pathSplit
Dim i
Dim AppPath

Set objFso = CreateObject("Scripting.FileSystemObject")

'AvpX̎擾
pathSplit = Split(WScript.ScriptFullName, "\")
AppPath = ""
For i = 0 to Ubound(pathSplit) - 1
    AppPath = AppPath & pathSplit(i) & "\"
Next

'dNh~
If objFso.FileExists(AppPath & lockFile) Then
    Set objFso = NoThing
    WScript.Echo "NBBB"
    WScript.Quit
Else
    Set objFile = objFso.CreateTextFile(AppPath & lockFile, true)
    objFile.Close
End If

'init@C̎擾
Set objFile = objFso.OpenTextFile(AppPath & "thisis.ini", 1, 1)
Do Until objFile.AtEndOfStream
    strVal = objFile.ReadLine
    aryStrings = Split(strVal, "=")
    If UBound(aryStrings) >= 1 then
        Select Case aryStrings(0)
            Case "v2c_Folder"
                v2c_Folder = aryStrings(1)
            Case "syncFolder"
                syncFolder = aryStrings(1)
            Case Else
        End Select
    end if
Loop
objFile.Close

'v2cN`FbN
If objFso.FileExists(v2c_Folder & "\..\" & "lockfile") = True Then
    WScript.Echo "v2cNłBBB"

    'dNbN
    objFso.DeleteFile AppPath & lockFile

    Set objFso  = NoThing
    Set objFile = Nothing
    WScript.Quit
End If

If objFso.FolderExists(v2c_Folder) = False Then
    WScript.Echo v2c_Folder & "܂BBB"

    'dNbN
    objFso.DeleteFile AppPath & lockFile

    Set objFso  = NoThing
    Set objFile = Nothing
    WScript.Quit
End If

If objFso.FolderExists(syncFolder) = False Then
    WScript.Echo syncFolder & "܂BBB"

    'dNbN
    objFso.DeleteFile AppPath & lockFile

    Set objFso  = NoThing
    Set objFile = Nothing
    WScript.Quit
End If

'v2cdatt@C𓯊tH_ɃRs[
Set outStrm = CreateObject("ADODB.Stream")
outStrm.Type          = adTypeText
outStrm.CharSet       = enc_UTF8
outStrm.LineSeparator = adLF
outStrm.Open

ChkAndCopyDat v2c_Folder

outStrm.SaveToFile AppPath & v2cCache, adSaveCreateOverWrite
outStrm.Close

'v2cō폜(v2cɑ݂Ȃ)X2chMate폜
DelOldDat syncFolder

'tH_J
Set objShell = Createobject("wscript.shell")
objShell.run """" & syncFolder & """"
Set objShell = Nothing

'dNbN
objFso.DeleteFile AppPath & lockFile

Set objFso   = Nothing
Set objFile  = Nothing



'v2cdatt@C𓯊tH_ɃRs[
Private Sub ChkAndCopyDat(parent)
    Const bbs_jbbs  = "jbbs_"
    Const host_jbbs = "jbbs.livedoor.jp"
    Const Host_jbbs_alias = "jbbs.shitaraba.com"

    Dim objFso
    Dim objSubfolders
    Dim objFile
    Dim objSyn
    Dim objSize

    Dim itaName
    Dim strArr
    Dim datName

    Dim FileSize_Syn
    Dim reNew

    Set objFso   = CreateObject("Scripting.FileSystemObject")
    For Each objSubfolders In objFso.GetFolder(parent).Subfolders
        If objSubfolders.Name <> "" Then
            ChkAndCopyDat parent & "\" & objSubfolders.Name
        End If
    Next

    strArr  = Split(parent, "\")
    itaName = strArr(UBound(strArr))

    Set objFso   = CreateObject("Scripting.FileSystemObject")
    For Each objFile In objFso.GetFolder(parent).Files
        If Right(objFile.Name, ext_len) = ext_dat Or Right(objFile.Name, ext_len) = ext_cgi Then
            '2chMatept@CҏW
            If getUrl(bbstree_2ch, itaName) <> "" Or getUrl(bbstree_machi, itaName) <> "" Then
                datName = itaName  & "_" & objFile.Name
            Else
                datName = parent
                datName = Replace(datName, v2c_Folder & "\", "")
                If inStr(parent, bbs_jbbs) > 0 Then
                    datName = Replace(datName, bbs_jbbs, Host_jbbs)
                End If
                datName = Replace(datName, "\", "%2F")
                datName = datName & "_" & objFile.Name
            End If

            't@CTCYrtH_̕傫ꍇ͓tH_XVȂ
            reNew = True
            If objFso.FileExists(syncFolder & "\" & Replace(datName, ext_cgi, ext_dat)) = True Then
                Set objSyn  = objFso.GetFile(syncFolder & "\" & Replace(datName,  ext_cgi, ext_dat))
                FileSize_Syn = objSyn.Size
                Set objSize = objFso.GetFile(parent &     "\" & objFile.Name)

                If FileSize_Syn >= objSize.Size Then
                    objSyn.Name = objSyn.Name & ext_syn
                    reNew = False
                End If
            End If

            'datu
            If reNew = True Then
                'v2cdatt@C𓯊tH_ɃRs[
                objFso.CopyFile parent & "\" & objFile.Name, syncFolder & "\" & Replace(datName,  ext_cgi, ext_dat) & ext_syn, True
            End If

            outStrm.WriteText parent & "\" & objFile.Name & "," & objFile.Size, adWriteLine
        End If
    Next

    Set objFso        = Nothing
    Set objSubfolders = Nothing
    Set objFile       = Nothing
    Set objSyn        = Nothing
    Set objSize       = Nothing

End Sub

'bbstreeurl擾
Private Function getUrl(in_Folder, in_itaName)

    Dim srcStrm

    Dim strVal
    Dim wkStrArr

    Set srcStrm = CreateObject("ADODB.Stream")
    srcStrm.Type          = adTypeText
    srcStrm.CharSet       = enc_UTF8
    srcStrm.LineSeparator = adLF

    srcStrm.Open
    srcStrm.LoadFromFile v2c_Folder & "\.." & "\" & bbsFolder & "\" & in_Folder & "\" & treeFile
    Do While Not srcStrm.EOS
        strVal = srcStrm.ReadText(adReadLine)
        '/͂ŕ⊮
        If inStr(strVal, "/" & in_itaName & "/") > 0 Then
            wkStrArr = Split(strVal, ",")
            strVal   = wkStrArr(1)
            Exit Do
        End if
        strVal = ""
    Loop
    srcStrm.Close

    Set srcStrm = Nothing

    getUrl = strVal

End Function

'v2cō폜(v2cɑ݂Ȃ)X2chMate폜
Private Sub DelOldDat(in_syncFolder)

    Dim objFso
    Dim objFile

    Set objFso   = CreateObject("Scripting.FileSystemObject")

    For Each objFile In objFso.GetFolder(in_syncFolder).Files
        If Right(objFile.Name, ext_len) = ext_dat Then
            objFso.DeleteFile in_syncFolder & "\"  & objFile.Name

        ElseIf Right(objFile.Name, ext_len) = ext_syn Then
            objFile.Name = Replace(objFile.Name, ext_syn, "")

        '.dat̂Ȃ.dat.tmp͍폜
        ElseIf Right(objFile.Name, ext_len) = ext_tmp Then
            If objFso.FileExists(in_syncFolder & "\" & Replace(objFile.Name, ext_tmp, "")) = False Then
                objFso.DeleteFile in_syncFolder & "\"  & objFile.Name
            End If
        End If
    Next

    Set objFso  = Nothing
    Set objFile = Nothing

End Sub
